<template>
  <div class="dark:bg-zinc-900">
    <router-view />

    <my-footer />
  </div>
</template>

<script lang="ts" setup>
  import { provide, reactive } from 'vue'
  import MyFooter from './components/Footer.vue'
  import { LocationType } from '../../shared/user-location.model'
  import {
    ownInstanceName,
    ownInstanceRedirectURI,
  } from './plugins/preferredInstance'
  import { getConfig } from './shared/config'
  import { CategoryStatsModel } from '../../shared/stats.model'
  import { getCategoryStats } from './shared/stats'
  import { UserInstanceData } from '../../shared/remote-instance'
  import { useGettext } from 'vue3-gettext'

  const userLocation = reactive<LocationType>({
    lon: null,
    lat: null,
    name: null,
    picture: null,
    isIPLocation: true,
    accuracy: 1,
  })

  const updateUserLocation = (newLocation: LocationType) => {
    userLocation.lat = newLocation.lat
    userLocation.lon = newLocation.lon
    userLocation.name = newLocation.name
    userLocation.picture = newLocation.picture
    userLocation.isIPLocation = newLocation.isIPLocation
    userLocation.accuracy = newLocation.accuracy
  }

  const config = await getConfig()

  if (config.ipLocation) {
    updateUserLocation({
      lat: config.ipLocation.centroid[1],
      lon: config.ipLocation.centroid[0],
      name: config.ipLocation.country.name,
      isIPLocation: true,
      accuracy: Math.round(
        (config.ipLocation.location?.accuracy_radius ?? 100) * 2
      ),
    })
  }

  provide('config', config)

  provide('userLocation', {
    userLocation,
    updateUserLocation,
  })

  const instanceRedirectURI = ownInstanceRedirectURI()
  const instanceName = ownInstanceName()

  const userInstance = reactive<UserInstanceData>({
    instanceRedirectURI,
    instanceName,
  })

  const updateUserInstance = (newUserInstance: UserInstanceData) => {
    console.debug('updateUserInstance', newUserInstance)
    userInstance.instanceName = newUserInstance.instanceName
    userInstance.instanceRedirectURI = newUserInstance.instanceRedirectURI
  }

  provide('userInstance', userInstance)
  provide('updateUserInstance', updateUserInstance)

  const { $gettext } = useGettext()

  const categoryStats = reactive<CategoryStatsModel[]>(
    await getCategoryStats($gettext)
  )

  provide('categoryStats', categoryStats)
</script>
